//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "CurvesUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//pragma link "PERFGRAP"
#pragma resource "*.dfm"
TCurvesForm *CurvesForm;
//---------------------------------------------------------------------------
const multip=5120.0;
//---------------------------------------------------------------------------
__fastcall TCurvesForm::TCurvesForm(TComponent* Owner)
        : TForm(Owner)
{
	TranslateForm(this);
	resizerThread=NULL;
	mode=cmQuant;
	cruveSeries=NULL;
    MouseDown=false;
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::CancelButtonClick(TObject *Sender)
{
  ModalResult=mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::FormShow(TObject *Sender)
{
    if (resizerThread!=NULL) return;
    //Liczymy histogram
    cruveSeries=NULL;
    CurvesForm->HistoChart->SeriesList->Clear();
    Extended *histR=new Extended[256];
    Extended *histG=new Extended[256];
    Extended *histB=new Extended[256];

    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    resizerThread->srcPict=srcPict;
    resizerThread->destPict=NULL;
    resizerThread->destBufR=histR;
    resizerThread->destBufG=histG;
    resizerThread->destBufB=histB;
    resizerThread->function=tfCreateHistBitmap;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ProcessingCompleteEvent;
    resizerThread->Resume();
//    resizerThread->CountHistogram(histR,histG,histB,srcPict);
  MouseDown=false;
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::FormDestroy(TObject *Sender)
{
  if (resizerThread!=NULL)
    resizerThread->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::HistoChartMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  MouseDown=false;
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::HistoChartMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if (Button==mbLeft)
    {
    if (cruveSeries==NULL) return;
    Extended xValueF=cruveSeries->XScreenToValue(X);
    if ((xValueF<-5.0)||(xValueF>260)) return;
    MouseDown=true;
    uint xValue=max(Floor(xValueF),0);
    lastMouseDownX=min(xValue,255);
    HistoChartMouseMove(Sender,Shift,X,Y);
    }
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::HistoChartMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if (MouseDown)
    {
    if (cruveSeries==NULL) return;
    Extended xValueF=cruveSeries->XScreenToValue(X);
    if ((xValueF<-5.0)||(xValueF>260)) return;
    //Mamy poprawn wspolrzdn X, zaorkrglamy j
    uint xValue=max(Floor(xValueF),0);
    xValue=min(xValue,255);
	CoordXEdit->Text = IntToStr((int)xValue);
	//Super - teraz trzeba jeszcze Y:
	Extended yValueF=cruveSeries->YScreenToValue(Y);
	uint yValue=max(Floor(yValueF),0);
	yValue=min(yValue,255);
    CoordYEdit->Text=IntToStr((int)yValue);
    //I zapisujemy nowy punkt krzywej
    cruveSeries->YValue[xValue]=Extended(yValue);
    //Jak trzeba to poprawiamy punkty nastpne lub poprzednie
    int MouseDownRange=xValue-lastMouseDownX;
    if ((MouseDownRange>1)&&(MouseDownRange<40))
      {
      uint yValueLast=cruveSeries->YValue[lastMouseDownX];
      for (int i=lastMouseDownX+1;i<(int)xValue;i++)
        cruveSeries->YValue[i]=Extended((i-lastMouseDownX)*yValue+(xValue-i)*yValueLast)/(MouseDownRange);
      }
     else
    if ((MouseDownRange<-1)&&(MouseDownRange>-40))
      {
      uint yValueLast=cruveSeries->YValue[lastMouseDownX];
      for (int i=xValue+1;i<lastMouseDownX;i++)
        cruveSeries->YValue[i]=Extended((lastMouseDownX-i)*yValue+(i-xValue)*yValueLast)/(-MouseDownRange);
      }
    lastMouseDownX=xValue;
    }
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::ProcessingCompleteEvent(TObject *Sender)
{
    TBitmapProcesorThread *oldResizer=resizerThread;
    resizerThread=NULL;
    oldResizer->srcPict=NULL;
    oldResizer->FreeOnTerminate=true;

    Extended *histR=oldResizer->destBufR;
    Extended *histG=oldResizer->destBufG;
    Extended *histB=oldResizer->destBufB;

    TAreaSeries *HistoRbg=new TAreaSeries(CurvesForm->HistoChart);
    TAreaSeries *HistoGbg=new TAreaSeries(CurvesForm->HistoChart);
    TAreaSeries *HistoBbg=new TAreaSeries(CurvesForm->HistoChart);
    TAreaSeries *HistoRG=new TAreaSeries(CurvesForm->HistoChart);
    TAreaSeries *HistoGB=new TAreaSeries(CurvesForm->HistoChart);
    TAreaSeries *HistoRB=new TAreaSeries(CurvesForm->HistoChart);
    TAreaSeries *HistoMin=new TAreaSeries(CurvesForm->HistoChart);
    HistoRbg->AreaLinesPen->Visible=false;
    HistoGbg->AreaLinesPen->Visible=false;
    HistoBbg->AreaLinesPen->Visible=false;
    HistoRG->AreaLinesPen->Visible=false;
    HistoGB->AreaLinesPen->Visible=false;
    HistoRB->AreaLinesPen->Visible=false;
    HistoMin->AreaLinesPen->Visible=false;
    HistoRbg->Stairs=true;
    HistoGbg->Stairs=true;
    HistoBbg->Stairs=true;
    HistoRG->Stairs=true;
    HistoGB->Stairs=true;
    HistoRB->Stairs=true;
    HistoMin->Stairs=true;
    HistoRbg->SeriesColor=(TColor)0x008A8AFF;//4545DE
    HistoGbg->SeriesColor=(TColor)0x0052E890;//2AB148
    HistoBbg->SeriesColor=(TColor)0x00FFAAA6;//CD5653
    HistoRG->SeriesColor=(TColor)0x00228D8C;
    HistoGB->SeriesColor=(TColor)0x008C8D22;
    HistoRB->SeriesColor=(TColor)0x00952696;
    HistoMin->SeriesColor=(TColor)0x002A2A2A;
  //Uzupeniamy dane serii
  for (uint nI = 0 ; nI<256 ; nI++)
    {
    HistoRbg->AddXY(nI, histR[nI]*multip, "", clTeeColor);
    HistoGbg->AddXY(nI, histG[nI]*multip, "", clTeeColor);
    HistoBbg->AddXY(nI, histB[nI]*multip, "", clTeeColor);
    HistoRG->AddXY(nI, min(histR[nI],histG[nI])*multip, "", clTeeColor);
    HistoGB->AddXY(nI, min(histG[nI],histB[nI])*multip, "", clTeeColor);
    HistoRB->AddXY(nI, min(histR[nI],histB[nI])*multip, "", clTeeColor);
    HistoMin->AddXY(nI, min(min(histR[nI],histG[nI]),histB[nI])*multip, "", clTeeColor);
    }
    //a to eby pasek 255 by widoczny
    HistoRbg->AddXY(256, 0, "", clTeeColor);
    HistoGbg->AddXY(256, 0, "", clTeeColor);
    HistoBbg->AddXY(256, 0, "", clTeeColor);
    HistoRG->AddXY(256, 0, "", clTeeColor);
    HistoGB->AddXY(256, 0, "", clTeeColor);
    HistoRB->AddXY(256, 0, "", clTeeColor);
    HistoMin->AddXY(256, 0, "", clTeeColor);
  CurvesForm->HistoChart->AddSeries(HistoRbg);
  CurvesForm->HistoChart->AddSeries(HistoGbg);
  CurvesForm->HistoChart->AddSeries(HistoBbg);
  CurvesForm->HistoChart->AddSeries(HistoRG);
  CurvesForm->HistoChart->AddSeries(HistoGB);
  CurvesForm->HistoChart->AddSeries(HistoRB);
  CurvesForm->HistoChart->AddSeries(HistoMin);
  //Czycimy bufory
  delete histR;
  delete histG;
  delete histB;

  cruveSeries=new TFastLineSeries(CurvesForm->HistoChart);
  cruveSeries->SeriesColor=clBlack;
  for (uint nI = 0 ; nI<=255 ; nI++)
    cruveSeries->AddXY(nI, nI, "", clTeeColor);
  CurvesForm->HistoChart->AddSeries(cruveSeries);

  //Ustawienia pocztkowe zmiennych
  TypeRadioGroupClick(Sender);
  ChannelRadioGroupClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::FormHide(TObject *Sender)
{
  if (resizerThread!=NULL)
    resizerThread->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::OkButtonClick(TObject *Sender)
{
  if (resizerThread==NULL)
      {
      ChannelRadioGroupClick(Sender);
      GetCurveFromChart();
      ModalResult=mrOk;
      }
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::TypeRadioGroupClick(TObject *Sender)
{
          mode=(eCurveMode)TypeRadioGroup->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TCurvesForm::ChannelRadioGroupClick(TObject *Sender)
{
  channel=(destChannel)ChannelRadioGroup->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TCurvesForm::GetCurveFromChart()
{
    if (cruveSeries==NULL) return;
    for (uint nI = 0 ; nI<=255 ; nI++)
      curve[nI]=Floor(cruveSeries->YValue[nI]+0.49);
}
//---------------------------------------------------------------------------

