//---------------------------------------------------------------------------

#ifndef CurvesUnitH
#define CurvesUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include "PERFGRAP.h"
#include <Chart.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <Series.hpp>
#include "BitmapProcesorUnit.h"
#include "FXProcs.h"
//---------------------------------------------------------------------------
  enum eCurveMode
          {
          cmVector = 0,
          cmQuant  = 1
          };
//---------------------------------------------------------------------------
class TCurvesForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TPanel *Panel2;
        TSpeedButton *OkButton;
        TSpeedButton *CancelButton;
        TChart *HistoChart;
        TAreaSeries *Series1;
        TAreaSeries *Series2;
        TFastLineSeries *Series3;
        TEdit *CoordXEdit;
        TEdit *CoordYEdit;
        TLabel *Label1;
        TLabel *Label2;
        TRadioGroup *ChannelRadioGroup;
        TRadioGroup *TypeRadioGroup;
        void __fastcall CancelButtonClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall HistoChartMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall HistoChartMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall HistoChartMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall FormHide(TObject *Sender);
        void __fastcall OkButtonClick(TObject *Sender);
        void __fastcall TypeRadioGroupClick(TObject *Sender);
        void __fastcall ChannelRadioGroupClick(TObject *Sender);
private:	// User declarations
        TBitmapProcesorThread *resizerThread;
        eCurveMode mode;
        bool MouseDown;
        int lastMouseDownX;
        TFastLineSeries *cruveSeries;
        void __fastcall ProcessingCompleteEvent(TObject *Sender);
        void __fastcall GetCurveFromChart();
public:		// User declarations
        Graphics::TBitmap *srcPict;
        destChannel channel;
        uchar *curve;
        __fastcall TCurvesForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TCurvesForm *CurvesForm;
//---------------------------------------------------------------------------
#endif
