//---------------------------------------------------------------------------

#ifndef FXProcsH
#define FXProcsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <climits>
//---------------------------------------------------------------------------
  const char Digits[]={'0','1','2','3','4','5','6','7','8','9',0};
  const char Symbols[]={'-','_','.',' ','~',',',';','|','\\','/','!','#','%','^','&','*','?','`','\'',0};
  const char SmallLetters[]={'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',0};
  const char LargeLetters[]={'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',0};
  const char Letters[]={'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
                        'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',0};
  const char WordCharsPl[] = {'0','1','2','3','4','5','6','7','8','9',
                              'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
                              'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
                              '_','\'','','','','','','','','','','','','','','','','','','',0};
//---------------------------------------------------------------------------
  const unsigned __int64 MaxSafeIntVal=LLONG_MAX;
  const int HugeIntSize=8;
//---------------------------------------------------------------------------
  typedef unsigned int uint;
  typedef unsigned short ushort;
  typedef unsigned char uchar;
//---------------------------------------------------------------------------
  const String PriorTimeCriticalText="TimeCritical";
  const String PriorHighestText="Highest";
  const String PriorHigherText="Higher";
  const String PriorNormalText="Normal";
  const String PriorLowerText="Lower";
  const String PriorLowestText="Lowest";
  const String PriorIdleText="Idle";
//---------------------------------------------------------------------------
#define max(a, b)  (((a) > (b)) ? (a) : (b))
#define min(a, b)  (((a) < (b)) ? (a) : (b))  
//---------------------------------------------------------------------------
#define _(str) TranslateToPL(str)
const String TranslateToPL(const String Str);
void __fastcall TranslateForm(TForm* form);
//---------------------------------------------------------------------------
  bool IsAsText(int,String);
  bool IsAsCategory(int PosInStr,String Str);
  bool IsBeforeEqu(int PosInStr,String Str);
//---------------------------------------------------------------------------
  String GetBefore(String Chr,String Str);
  String GetAfter(String Chr,String Str);
  String GetAfterLast(String Chr,String Str);
  String GetBetween(String Ch1,String Ch2,String Str);
  int BackPos(String Chr,String Str);
//---------------------------------------------------------------------------
  String GetDAPathFromStr(String,int);
  void PrepareMathLine(String &);
  int WhereIsClosing(String Line);
  String RemoveWhatInBrackets(String);
  bool StrIsDecNum(String Str);
  bool StrIsHexNum(String Str);
  bool StrIsBinNum(String Str);
  bool StrIsAnyNum(String Str);
  int BinToInt(String Str);
  String IntToBin(int Num,int MinDigits);
  String FormatString(String str);
  String DeFormatString(String str);
  bool StrToBoolean(const String &str);
  String BooleanToStr(bool val);
  TThreadPriority StrToPriority(const String &str);
  String PriorityToStr(TThreadPriority val);
  TControl* FindAnyChildControl(TWinControl *Parent,const AnsiString &ControlName);
  int FindSubstringPosFrom(int startIndex,String SubStr,String MainString);
  int FindSubMemPos(const char *SubBuf,uint SubBufSize,const char *MainBuf,uint MainBufSize);
  String ChangeCaseWordsStartsBig(const String &SrcStr);
//---------------------------------------------------------------------------
enum FileCopyOptions
      {
      FC_OVERWRITE           =  1,
      FC_ACTUALDATE          =  2
      };
const int FileCopyReadBufSize=65536;
//---------------------------------------------------------------------------
int FileCopy(String SourceFile,String DestFile,int Options);
//---------------------------------------------------------------------------
#endif
