//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ExtendedGauge"
#pragma resource "*.dfm"
TLisoszopMainForm *LisoszopMainForm;
//---------------------------------------------------------------------------
__fastcall TLisoszopMainForm::TLisoszopMainForm(TComponent* Owner)
        : TForm(Owner)
{
	TranslateForm(this);
    MouseDown = false;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::OpenButtonClick(TObject *Sender)
{
  if (OpenPictureDialog->Execute())
      {
      if (OpenPictureDialog->FilterIndex==6)
          {//Plik RAW
          OpenRawForm->RawFileName=OpenPictureDialog->FileName;
          int RawResult=OpenRawForm->ShowModal();
          if (RawResult==mrOk)
              WorkImage->Picture->Assign(OpenRawForm->WorkImage->Picture);
          OpenRawForm->WorkImage->Picture->Bitmap->FreeImage();
          }
        else
          {//Zwyky obrazek
          WorkImage->Picture->LoadFromFile(OpenPictureDialog->FileName);
          }
      NormZoomButtonClick(Sender);
      };
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::ZoomComboBoxKeyPress(TObject *Sender,
      char &Key)
{
  if (Key==VK_RETURN)
    {
    Extended zoom=StrToIntDef(ZoomComboBox->Text,100);
    zoom=zoom/100;
    if (zoom<0) zoom=-zoom;
    Extended newHeight=zoom*WorkImage->Picture->Height;
    Extended newWidth=zoom*WorkImage->Picture->Width;
    WorkImage->Height=max(Floor(newHeight),1);
    WorkImage->Width=max(Floor(newWidth),1);
    MainScrollBox->HorzScrollBar->Range=WorkImage->Width;
    MainScrollBox->VertScrollBar->Range=WorkImage->Height;

    Key=0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::NormZoomButtonClick(TObject *Sender)
{
      ZoomComboBox->Text="100";
      char Key=VK_RETURN;
      ZoomComboBoxKeyPress(ZoomComboBox,Key);
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::ZoomInButtonClick(TObject *Sender)
{
    int zoom=StrToIntDef(ZoomComboBox->Text,50);
    if (zoom<0) zoom=-zoom;
    if (zoom<1)
        zoom=1;
      else
        zoom*=2;
    if (zoom>50000)
        zoom=50000;

    ZoomComboBox->Text=IntToStr(zoom);
    char Key=VK_RETURN;
    ZoomComboBoxKeyPress(ZoomComboBox,Key);
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::ZoomOutButtonClick(TObject *Sender)
{
    int zoom=StrToIntDef(ZoomComboBox->Text,50);
    if (zoom<0) zoom=-zoom;
    zoom/=2;
    if (zoom>0)
        {
        ZoomComboBox->Text=IntToStr(zoom);
        char Key=VK_RETURN;
        ZoomComboBoxKeyPress(ZoomComboBox,Key);
        }
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::ResizeImageButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Okienko z funkcjami programu
    ResizerForm->prevWidth=srcPict->Width;
    ResizerForm->prevHeight=srcPict->Height;
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    if ((AllowConvert!=IDYES)||(ResizerForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    TAdvancedBitmap *destPict=new TAdvancedBitmap();
    destPict->PixelFormat=pf24bit;
    destPict->Width=ResizerForm->newWidth;
    destPict->Height=ResizerForm->newHeight;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Nie przeszkadzaj mnie tera bo ja robie...";
    resizerThread->function=tfResizeBitmap;
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    //No i pora zajc si tworzeniem
    switch (ResizerForm->InterpolationRadioGroup->ItemIndex)
      {
      case 1:resizerThread->fmode=kLinearInterp;break;
      case 2:resizerThread->fmode=kCubicInterp;break;
      default:resizerThread->fmode=kPoint;
      }
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::ResizeTerminateEvent(TObject *Sender)
{
    ProgressTimer->Enabled=false;
    WorkImage->Picture->Assign(resizerThread->destPict);
    TBitmapProcesorThread *oldResizer=resizerThread;
    resizerThread=NULL;
    delete oldResizer->srcPict;
    delete oldResizer->destPict;
    //delete oldResizer;
    oldResizer->FreeOnTerminate=true;
    ResizeToolBar->Enabled=true;
    FileToolBar->Enabled=true;
    GenerateToolBar->Enabled=true;
    FilterToolBar->Enabled=true;
    TransformToolBar->Enabled=true;
    MainStatusBar->Panels->Items[0]->Text="No i pozamiatane.";
    char Key=VK_RETURN;
    ZoomComboBoxKeyPress(ZoomComboBox,Key);
    MainStatusBar->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::ProgressTimerTimer(TObject *Sender)
{
  ProgressTimer->Enabled=false;
  MainStatusBar->Invalidate();
  ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::SaveButtonClick(TObject *Sender)
{
  SavePictureDialog->FileName=OpenPictureDialog->FileName;
  if (!SavePictureDialog->Execute()) return;
  switch (SavePictureDialog->FilterIndex)
    {
    case 1:
      {
      TAdvancedBitmap *srcPict=new TAdvancedBitmap();
      srcPict->Assign(WorkImage->Picture->Graphic);
      srcPict->SaveToFile(SavePictureDialog->FileName);
      WorkImage->Picture->Assign(srcPict);
      delete srcPict;
      };break;
    case 2:
      {
      TJPEGImage *srcPict=new TJPEGImage();
      srcPict->Assign(WorkImage->Picture->Graphic);
      srcPict->CompressionQuality=80;
      srcPict->ProgressiveEncoding=false;
      srcPict->JPEGNeeded();
      srcPict->Compress();
      srcPict->SaveToFile(SavePictureDialog->FileName);
      WorkImage->Picture->Assign(srcPict);
      delete srcPict;
      };break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::MainStatusBarDrawPanel(TStatusBar *StatusBar, TStatusPanel *Panel, const TRect &Rect)
{
  Graphics::TBitmap *TheImage=new Graphics::TBitmap();
  TBltBitmap *OverlayImage=new TBltBitmap();

  TheImage->Height = StatusBar->ClientHeight;
  TheImage->Width = Rect.Width();
  //TheImage->Width = Panel->Width;
  TheImage->Canvas->TryLock();
  TRect  ARect;
  ARect = TRect(0, 0, TheImage->Width, TheImage->Height);
  Extended PercentDone=0.0;
  TheImage->Canvas->Font->Assign(this->Font);
  OverlayImage->MakeLike(TheImage);

  if ((resizerThread!=NULL)&&(!resizerThread->Suspended))
      {
      PercentDone=resizerThread->AdvancePos/(resizerThread->AdvanceMax+0.0001)*100.0;
      //resizerThread->PaintBitmapBackground(OverlayImage,cmBlackness);
      resizerThread->PaintBarOnBitmap(OverlayImage,ARect,clBlack,clWhite,sbHorizontal,PercentDone);
      TheImage->Canvas->CopyMode = cmSrcInvert;
      TheImage->Canvas->Draw(0, 0, OverlayImage);
      String  S;
      S = FloatToStrF(PercentDone,ffNumber,4,2);
      S += " %";
      resizerThread->PaintTextOnBitmap(TheImage,ARect,S);
      }
    else
      {
      TheImage->Canvas->CopyMode = cmBlackness;
      TheImage->Canvas->CopyRect(ARect, TheImage->Canvas, ARect);
      TheImage->Canvas->CopyMode = cmSrcCopy;
      //InflateRect(&ARect, -1, -1);
      TheImage->Canvas->Brush->Style = bsClear;
      TheImage->Canvas->Font->Color = clWhite;
      String  Str="gotowy";
      Integer X, Y;
      X = (ARect.Right - ARect.Left + 1 - TheImage->Canvas->TextWidth(Str)) / 2;
      Y = (ARect.Bottom - ARect.Top + 1 - TheImage->Canvas->TextHeight(Str)) / 2;
      TheImage->Canvas->TextRect(ARect, X, Y, Str);

      }
//  StatusBar->Canvas->TryLock(); - to jest wywolywane przez cos innego....
  StatusBar->Canvas->CopyMode = cmSrcCopy;
  StatusBar->Canvas->Draw(Rect.Left, Rect.Top, TheImage);
  TheImage->Canvas->Unlock();
//  StatusBar->Canvas->Unlock();
  delete TheImage;
  delete OverlayImage;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::MainStatusBarClick(TObject *Sender)
{
  if ((resizerThread!=NULL)&&(!resizerThread->Suspended))
    {
    int Result=MessageBox(0,"Ej no co? Ja ROBIEM. Chcesz ebym da se spokj?",
            "Co ty niby robisz, co?",MB_YESNO|MB_TASKMODAL|MB_ICONWARNING);
    if (Result==IDYES)
        resizerThread->Terminate();
    }
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::AbstractGeneratorButtonClick(TObject *Sender)
{
    if (AbstractGeneratorForm->ShowModal()!=mrOk)
        return;
    TAdvancedBitmap *filter=new TAdvancedBitmap();
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Mylem nad ksztatem...";
    resizerThread->destPict=filter;
    resizerThread->srcPict=NULL;
    resizerThread->extParam=AbstractGeneratorForm->level;
    resizerThread->extParamInt=AbstractGeneratorForm->NumberTrackBar->Position;
    resizerThread->newWidthParam=AbstractGeneratorForm->newWidth;
    resizerThread->newHeightParam=AbstractGeneratorForm->newHeight;
    resizerThread->function=tfAbstractPaint;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::NewButtonClick(TObject *Sender)
{
    //Okienko z funkcjami programu
    if (NewImgForm->ShowModal()!=mrOk)
        return;
    //Wybieramy rozmiar i parametry nowego obrazu
    TAdvancedBitmap *destPict=new TAdvancedBitmap();
    destPict->PixelFormat=pf24bit;
    destPict->Width=NewImgForm->newWidth;
    destPict->Height=NewImgForm->newHeight;
    unsigned int bkColor=ColorToRGB(NewImgForm->ColorPanel->Color);
    uchar bcRed=(bkColor)&0xff;
    uchar bcGreen=(bkColor>>8)&0xff;
    uchar bcBlue=(bkColor>>16)&0xff;
    for (int i=0;i<destPict->Height;i++)
        for (int j=0;j<destPict->Width;j++)
          {
          ((uchar *)destPict->ScanLine[i])[j*3]=bcBlue;
          ((uchar *)destPict->ScanLine[i])[j*3+1]=bcGreen;
          ((uchar *)destPict->ScanLine[i])[j*3+2]=bcRed;
          }
    WorkImage->Picture->Assign(destPict);
    MainStatusBar->Panels->Items[0]->Text="Czary mary Potter Harry i obrazek zmalowany.";
    char Key=VK_RETURN;
    ZoomComboBoxKeyPress(ZoomComboBox,Key);
    MainStatusBar->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::GaussBlurSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Ostrzeenie o konwersji
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    //Okienko z funkcjami filtru
    if ((AllowConvert!=IDYES)||(FilterLevelForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    TAdvancedBitmap *destPict=new TAdvancedBitmap();
    destPict->PixelFormat=pf24bit;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="No to liczem se tego Gaussa...";
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    resizerThread->extParam=FilterLevelForm->level;
    resizerThread->function=tfGaussianFilter;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::GaussGeneratorSpeedButtonClick(
      TObject *Sender)
{
    if (FilterGeneratorForm->ShowModal()!=mrOk)
        return;
    TAdvancedBitmap *filter=new TAdvancedBitmap();
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Mylem nad ksztatem...";
    resizerThread->destPict=filter;
    resizerThread->srcPict=NULL;
    Extended levl=FilterGeneratorForm->level;
    if (levl>=0)
        levl=expl(levl);
      else
        levl=expl(6.23*levl/1000);
    resizerThread->extParam=levl*stromoscG;
    resizerThread->extParamInt=0;
    resizerThread->newWidthParam=FilterGeneratorForm->newWidth;
    resizerThread->newHeightParam=FilterGeneratorForm->newHeight;
    resizerThread->function=tfGaussianPaint;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::TriangleGeneratorSpeedButtonClick(TObject *Sender)
{
    if (FilterGenRotForm->ShowModal()!=mrOk)
        return;
    TAdvancedBitmap *filter=new TAdvancedBitmap();
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Mylem nad ksztatem...";
    resizerThread->destPict=filter;
    resizerThread->srcPict=NULL;
    Extended levl=-FilterGenRotForm->level;
    if (levl>=0)
        levl=levl/50;
      else
        levl=levl/200;
    resizerThread->extParam=levl*stromoscT;
    resizerThread->extParamAng=FilterGenRotForm->angle;
    resizerThread->extParamInt=0;
    resizerThread->newWidthParam=FilterGenRotForm->newWidth;
    resizerThread->newHeightParam=FilterGenRotForm->newHeight;
    resizerThread->function=tfTriangularPaint;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;

    //MainStatusBar->Panels->Items[0]->Text="a zrobiem ksztata...";
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::TriangBlurSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Ostrzeenie o konwersji
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    //Okienko z funkcjami filtru
    if ((AllowConvert!=IDYES)||(FilterLevelForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    TAdvancedBitmap *destPict=new TAdvancedBitmap();
    destPict->PixelFormat=pf24bit;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Pokrywam to tym no trjktnym filtrem...";
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    resizerThread->extParam=FilterLevelForm->level;
    resizerThread->function=tfTriangularFilter;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TLisoszopMainForm::MainScrollBoxMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if (Button==mbLeft)
      {
      MouseDown=true;
      MouseDownCoords.x=X;
      MouseDownCoords.y=Y;
      if (HandSpeedButton->Down)
          {
          Screen->Cursor=crHandClosed;
          Application->ProcessMessages();
          }
      }
    else
  if (Button==mbRight)
      {
      }
}
//---------------------------------------------------------------------------

void __fastcall TLisoszopMainForm::MainScrollBoxMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if (Button==mbLeft)
      {
      MouseDown=false;
      if (HandSpeedButton->Down)
        {
        Screen->Cursor=crDefault;
        }
       else
      if (DrawSpeedButton->Down)
        {
        }
       else
        {
        WorkImage->Cursor=crDefault;
        }
      }
    else
  if (Button==mbRight)
      {
      if (HandSpeedButton->Down)
          {
          if (MouseDown)
            {//Mamy przej lub wyj z penego ekranu
            if (LisoszopMainForm->BorderStyle!=bsNone)
                {
                lastWindowState=LisoszopMainForm->WindowState;
                lastBoundsRect=LisoszopMainForm->BoundsRect;
                LisoszopMainForm->BorderStyle=bsNone;
                if (lastWindowState!=wsMaximized)
                    LisoszopMainForm->WindowState=wsMaximized;
                }
              else
                {
                LisoszopMainForm->WindowState=lastWindowState;
                LisoszopMainForm->BorderStyle=bsSizeable;
                LisoszopMainForm->BoundsRect=lastBoundsRect;
                }
            }
        }
      }

}
//---------------------------------------------------------------------------

void __fastcall TLisoszopMainForm::MainScrollBoxMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if (MouseDown)
    {
    if (HandSpeedButton->Down)
      {//Aktywna funkcja przesuwania rk
      int deltaX=X-MouseDownCoords.x;
      int deltaY=Y-MouseDownCoords.y;
      TRect srcPos=WorkImage->BoundsRect;
      //eby nie wyj za ekran po stronie ujemnej
      if (MainScrollBox->ClientWidth>srcPos.Right+deltaX)
          deltaX=MainScrollBox->ClientWidth-srcPos.Right;
      if (MainScrollBox->ClientHeight>srcPos.Bottom+deltaY)
          deltaY=MainScrollBox->ClientHeight-srcPos.Bottom;
      //eby nie wyj za ekran po stronie dodatniej
      if (srcPos.Left+deltaX>0)
          deltaX=-srcPos.Left;
      if (srcPos.Top+deltaY>0)
          deltaY=-srcPos.Top;

      MainScrollBox->ScrollBy(deltaX,deltaY);
      MainScrollBox->HorzScrollBar->Position=-WorkImage->Left;
      MainScrollBox->VertScrollBar->Position=-WorkImage->Top;
      }
     else
    if (DrawSpeedButton->Down)
      {
      }
     else
      {
      }
    }
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::SharpenGeneratorSpeedButtonClick(TObject *Sender)
{
    if (FilterGeneratorForm->ShowModal()!=mrOk)
        return;
    TAdvancedBitmap *filter=new TAdvancedBitmap();
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Mylem nad ksztatem...";
    resizerThread->destPict=filter;
    resizerThread->srcPict=NULL;
    Extended levl=FilterGeneratorForm->level;
    if (levl>=0)
        levl=expl(levl);
      else
        levl=expl(6.23*levl/1000);
    resizerThread->extParam=levl*stromoscG;
    resizerThread->extParamInt=0;
    resizerThread->newWidthParam=FilterGeneratorForm->newWidth;
    resizerThread->newHeightParam=FilterGeneratorForm->newHeight;
    resizerThread->function=tfSharpenPaint;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::SharpenSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Ostrzeenie o konwersji
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    //Okienko z funkcjami filtru
    if ((AllowConvert!=IDYES)||(SharpenForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    TAdvancedBitmap *destPict=new TAdvancedBitmap();
    destPict->PixelFormat=pf24bit;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="No to liczem se te wyostrzenie...";
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    //Dopasowanie parametru do zakresu wyostrzania (1->1.94,10->2.299599)
    Extended modLevel=0.039955444*SharpenForm->level+1.90004455;
    resizerThread->extParam=modLevel;
    resizerThread->extParamAng=SharpenForm->size*2;
    resizerThread->function=tfSharpenFilter;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::FunctionSpeedButtonClick(
      TObject *Sender)
{
  if (HandSpeedButton->Down)
      {
      WorkImage->Cursor=crHandOpen;
      }
    else
  if (DrawSpeedButton->Down)
      {
      WorkImage->Cursor=crCross;
      }
    else
      {
      WorkImage->Cursor=crDefault;
      }
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::FormShow(TObject *Sender)
{
  FunctionSpeedButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TLisoszopMainForm::FormCreate(TObject *Sender)
{
  Screen->Cursors[crHandOpen] = LoadCursor(HInstance, "HandOpenCursor");
  Screen->Cursors[crHandClosed] = LoadCursor(HInstance, "HandClosedCursor");
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::EdgeGeneratorSpeedButtonClick(TObject *Sender)
{
    if (FilterGeneratorForm->ShowModal()!=mrOk)
        return;
    TAdvancedBitmap *filter=new TAdvancedBitmap();
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Mylem nad ksztatem...";
    resizerThread->destPict=filter;
    resizerThread->srcPict=NULL;
    Extended levl=FilterGeneratorForm->level+1000;
    resizerThread->extParam=levl/1997;
    resizerThread->extParamInt=0;
    resizerThread->newWidthParam=FilterGeneratorForm->newWidth;
    resizerThread->newHeightParam=FilterGeneratorForm->newHeight;
    resizerThread->function=tfEdgesPaint;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::FindEdgesSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Ostrzeenie o konwersji
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    //Okienko z funkcjami filtru
    if ((AllowConvert!=IDYES)||(SharpenForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    TAdvancedBitmap *destPict=new TAdvancedBitmap();
    destPict->PixelFormat=pf24bit;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Robiem krawdzia...";
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    //Dopasowanie parametru do zakresu wyostrzania (1->1.94,10->2.299599)
    Extended modLevel=SharpenForm->level;
    resizerThread->extParam=modLevel;
    resizerThread->extParamAng=SharpenForm->size*2;
    resizerThread->function=tfEdgesFilter;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TLisoszopMainForm::ColorDepthSpeedButtonClick(
      TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Okno konwersji
    ColorDepthForm->newBPP=srcPict->PixelFormat;
    if (ColorDepthForm->ShowModal()!=mrOk)
        return;
    //I skutek - zmiana formatu
    srcPict->PixelFormat=ColorDepthForm->newBPP;
    if (ColorDepthForm->MakeMonochromeCheckBox->Checked)
        srcPict->Monochrome=true;
    //Zapisujemy do mapy na ekranie
    WorkImage->Picture->Assign(srcPict);
    delete srcPict;
}
//---------------------------------------------------------------------------

void __fastcall TLisoszopMainForm::AboutSpeedButtonClick(TObject *Sender)
{
  AboutForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::FlipRotateSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Ostrzeenie o konwersji
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    //Okienko z funkcjami filtru
    if ((AllowConvert!=IDYES)||(FlipRotateForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    Graphics::TBitmap *destPict=new Graphics::TBitmap();
    destPict->PixelFormat=pf24bit;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Robiem obicie lub obrt...";
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    if (FlipRotateForm->FlipVRadioButton->Checked)
        {
        resizerThread->function=tfFlipBitmap;
        resizerThread->extParamInt=sbVertical;
        resizerThread->extParamAng=0;
        }
      else
    if (FlipRotateForm->FlipHRadioButton->Checked)
        {
        resizerThread->function=tfFlipBitmap;
        resizerThread->extParamInt=sbHorizontal;
        resizerThread->extParamAng=0;
        }
      else
    if (FlipRotateForm->RotateRadioButton->Checked)
        {
        resizerThread->function=tfRotateBitmap;
        resizerThread->extParamAng=FlipRotateForm->RotateAngle;
        resizerThread->extParamInt=FlipRotateForm->ExtendBitmapCheckBox->Checked;
        }
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::FFTSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Ostrzeenie o konwersji
    int AllowConvert=IDYES;
    int AskSure=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);
        }
      else
        {
        AskSure=
        MessageBox(NULL,"Obraz zostanie przeksztacony w cz rzeczywist wyniku transformaty Fouriera.\n\nCzy chcesz dokona przekrztacenia Fouriera algorytmem FFT obrazka?",
               "No to dawaj.",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);
        }
    //Okienko z funkcjami filtru
    if ((AllowConvert!=IDYES)||(AskSure!=IDYES))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    Graphics::TBitmap *destPict=new Graphics::TBitmap();
    destPict->PixelFormat=pf24bit;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Licze szybk Furie...";
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    resizerThread->function=tfFFTBitmap;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::RevFFTSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Ostrzeenie o konwersji
    int AllowConvert=IDYES;
    int AskSure=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);
        }
      else
        {
        AskSure=
        MessageBox(NULL,"Obraz zostanie przeksztacony w wynik odwrotnej transformaty Fouriera.\n\nCzy chcesz dokona przekrztacenia Fouriera algorytmem Reverse FFT obrazka?",
               "No to dawaj.",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);
        }
    //Okienko z funkcjami filtru
    if ((AllowConvert!=IDYES)||(AskSure!=IDYES))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    Graphics::TBitmap *destPict=new Graphics::TBitmap();
    destPict->PixelFormat=pf24bit;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Licze szybk Furie^-1...";
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    resizerThread->function=tfRFTBitmap;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::FFTGaussSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    Graphics::TBitmap *srcPict=new Graphics::TBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Ostrzeenie o konwersji
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    //Okienko z funkcjami filtru
    if ((AllowConvert!=IDYES)||(FilterLevelForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    Graphics::TBitmap *destPict=new Graphics::TBitmap();
    destPict->PixelFormat=pf24bit;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Liczem Gaussa przez FFT...";
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    resizerThread->extParam=FilterLevelForm->level;
    resizerThread->function=tfFFTGaussFilter;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::CurvesSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    Graphics::TBitmap *srcPict=new Graphics::TBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty)
      {
      delete srcPict;
      return;
      }
    //Okienko z funkcjami programu
    CurvesForm->srcPict=srcPict;
    uchar *curve=new char[256];
    CurvesForm->curve=curve;
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    if ((AllowConvert!=IDYES)||(CurvesForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Wykrzywiam (mno przez krzyw)...";
    resizerThread->destPict=srcPict;
    resizerThread->srcPict=NULL;
    resizerThread->curveParam=CurvesForm->curve;
    resizerThread->extParamInt=CurvesForm->ChannelRadioGroup->ItemIndex;
    resizerThread->function=tfCurvLevelsBitmap;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::AutoLevelsButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    Graphics::TBitmap *srcPict=new Graphics::TBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty)
      {
      delete srcPict;
      return;
      }
    //Okienko z funkcjami programu
//    LevelsForm->srcPict=srcPict;
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    if ((AllowConvert!=IDYES)||(LevelsForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Dopasowuj Ci histerozegrama...";
    resizerThread->destPict=srcPict;
    resizerThread->srcPict=NULL;
    resizerThread->extParamInt=LevelsForm->ChannelRadioGroup->ItemIndex;
    if (LevelsForm->FunctionRadio->ItemIndex==0)
        {
        resizerThread->function=tfAutoLevelsBitmap;
        }
      else
        {
        //Generujemy odpowiedni krzyw
        uchar *curve=new char[256];
        Extended StepY=255.0/Extended(LevelsForm->ExpandMax-LevelsForm->ExpandMin);
        int CurveStart=max(LevelsForm->ExpandMin,0);
        int CurveEnd=min(LevelsForm->ExpandMax,255);
        //Zapeniamy pocztek i koniec krzywej
        for (int nI=0;nI<CurveStart;nI++)
          curve[nI]=0;
        for (int nI=255;nI>CurveEnd;nI--)
          curve[nI]=255;
        //No i robimy rodek
        for (int nI=CurveStart;nI<=CurveEnd;nI++)
          curve[nI]=StepY*(nI-CurveStart);
        resizerThread->curveParam=curve;
        //I ustawiamy funkcj
        resizerThread->function=tfCurvLevelsBitmap;
        }
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TLisoszopMainForm::UserFilterSpeedButtonClick(TObject *Sender)
{
    //Pobieramy obraz rdowy
    TAdvancedBitmap *srcPict=new TAdvancedBitmap();
    if (!WorkImage->Picture->Graphic->Empty)
        srcPict->Assign(WorkImage->Picture->Graphic);
      else
        srcPict->Assign(WorkImage->Picture->Bitmap);
    if (srcPict->Empty) return;
    //Ostrzeenie o konwersji
    int AllowConvert=IDYES;
    if (srcPict->PixelFormat!=pf24bit)
        {
        AllowConvert=
        MessageBox(NULL,"This operation is implemented only for 24-bit bitmaps. The format of your image is different.\n\nDo you want to make a conversion?",
               "Automatic bit format conversion",MB_YESNO|MB_TASKMODAL|MB_ICONQUESTION);

        }
    //Okienko z funkcjami filtru
    if ((AllowConvert!=IDYES)||(UsrFilterForm->ShowModal()!=mrOk))
        {
        delete srcPict;
        return;
        }
    //Wybieramy rozmiar i parametry obrazu docelowego
    TAdvancedBitmap *destPict=new TAdvancedBitmap();
    destPict->PixelFormat=pf24bit;
    //No i aktywujemy wtek
    resizerThread=new TBitmapProcesorThread(true);
    resizerThread->Priority=tpLower;
    TransformToolBar->Enabled=false;
    ResizeToolBar->Enabled=false;
    FileToolBar->Enabled=false;
    GenerateToolBar->Enabled=false;
    FilterToolBar->Enabled=false;
    MainStatusBar->Panels->Items[0]->Text="Robiem t ca filtracj...";
    resizerThread->destPict=destPict;
    resizerThread->srcPict=srcPict;
    resizerThread->FilterBuf=UsrFilterForm->WspTable;
    resizerThread->extParamInt=UsrFilterForm->FilterSize;
    resizerThread->extParam=UsrFilterForm->Divider;
    resizerThread->extParamAng=UsrFilterForm->Adder;
    resizerThread->extParamFlag=UsrFilterForm->AbsoluteCheckBox->Checked;
    resizerThread->function=tfExternalFilter;
    UsrFilterForm->WspTable=NULL;
    //No i pora zajc si tworzeniem
    resizerThread->OnTerminate=ResizeTerminateEvent;
    resizerThread->Resume();
    ProgressTimer->Enabled=true;
}
//---------------------------------------------------------------------------

