//---------------------------------------------------------------------------

#ifndef MainFormH
#define MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <jpeg.hpp>
#include <Graphics.hpp>
#include <Math.hpp>
#include <jpeg.hpp>
#include "FilterLevelUnit.h"
#include "ResizerFormUnit.h"
#include "NewImageFormUnit.h"
#include "AbstractGeneratorFormUnit.h"
#include "FilterGeneratorFormUnit.h"
#include "FilterGenTriangleFormUnit.h"
#include "BitmapProcesorUnit.h"
#include "ExtendedGauge.hpp"
#include "SharpenLevelUnit.h"
#include "OpenRawUnit.h"
#include "ColorDepthFormUnit.h"
#include "AboutUnit.h"
#include "FlipRotateFormUnit.h"
#include "AdvancedBitmap.h"
#include "CurvesUnit.h"
#include "LevelsFormUnit.h"
#include "UserFilter.h"
#include <Menus.hpp>
#include <ImgList.hpp>
#include "FXProcs.h"
//---------------------------------------------------------------------------
const TCursor crHandOpen = 5;
const TCursor crHandClosed = 6;
//---------------------------------------------------------------------------
class TLisoszopMainForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *MainStatusBar;
        TPanel *MainPanel;
        TScrollBox *MainScrollBox;
        TImage *WorkImage;
        TOpenPictureDialog *OpenPictureDialog;
        TSavePictureDialog *SavePictureDialog;
        TTimer *ProgressTimer;
        TCoolBar *LeftCoolBar;
        TPanel *FunctionPanel;
        TSpeedButton *SpeedButton4;
        TSpeedButton *DrawSpeedButton;
        TSpeedButton *HandSpeedButton;
        TCoolBar *MainCoolBar;
        TToolBar *FileToolBar;
        TSpeedButton *NewButton;
        TSpeedButton *OpenButton;
        TSpeedButton *SaveButton;
        TToolBar *ZoomToolBar;
        TSpeedButton *ZoomInButton;
        TSpeedButton *ZoomOutButton;
        TSpeedButton *NormZoomButton;
        TComboBox *ZoomComboBox;
        TToolBar *ResizeToolBar;
        TSpeedButton *ResizeCanvasButton;
        TSpeedButton *ResizeImageButton;
        TSpeedButton *ColorDepthSpeedButton;
        TToolBar *GenerateToolBar;
        TSpeedButton *AbstractGeneratorButton;
        TSpeedButton *GaussGeneratorSpeedButton;
        TSpeedButton *TriangleGeneratorSpeedButton;
        TSpeedButton *SharpenGeneratorSpeedButton;
        TSpeedButton *EdgeGeneratorSpeedButton;
        TToolBar *FilterToolBar;
        TSpeedButton *GaussBlurSpeedButton;
        TSpeedButton *TriangBlurSpeedButton;
        TSpeedButton *SharpenSpeedButton;
        TSpeedButton *FindEdgesSpeedButton;
        TToolBar *HelpToolBar;
        TSpeedButton *AboutSpeedButton;
        TSpeedButton *FlipRotateSpeedButton;
        TToolBar *TransformToolBar;
        TSpeedButton *FFTSpeedButton;
        TSpeedButton *RevFFTSpeedButton;
        TSpeedButton *FFTGaussSpeedButton;
        TToolBar *HistogramToolBar;
        TSpeedButton *SpeedButton1;
        TSpeedButton *SpeedButton2;
        TSpeedButton *SpeedButton3;
        TSpeedButton *AutoLevelsButton;
        TSpeedButton *CurvesSpeedButton;
        TMainMenu *LisoszopMainMenu;
        TMenuItem *MenuFile;
        TMenuItem *MenuEdit;
        TMenuItem *MenuGenerate;
        TMenuItem *MenuFiltering;
        TMenuItem *Pomoc1;
        TMenuItem *Widok1;
        TMenuItem *MenuFourier;
        TMenuItem *MenuFileNew;
        TMenuItem *MenuFileOpen;
        TMenuItem *MenuFileSaveAs;
        TMenuItem *MenuSubClose;
        TMenuItem *Powiksz1;
        TMenuItem *Pomniejsz1;
        TMenuItem *Widok111;
        TMenuItem *Paskinarzdzi1;
        TMenuItem *N1;
        TMenuItem *Plik2;
        TMenuItem *Widok2;
        TMenuItem *MenuWymiarowanie1;
        TMenuItem *MenuGeneracja2;
        TMenuItem *MenuSubFiltry;
        TMenuItem *MenuSubFourier;
        TMenuItem *Pomoc2;
        TMenuItem *MenuHistogram;
        TMenuItem *MenuHistogram2;
        TImageList *MenuIconImages;
        TMenuItem *MenuHelpAbout;
        TMenuItem *uyjpaskw1;
        TMenuItem *uyjpaskw2;
        TMenuItem *uyjpaskw3;
        TMenuItem *uyjpaskw4;
        TMenuItem *uyjpaskw5;
        TSpeedButton *UserFilterSpeedButton;
        void __fastcall OpenButtonClick(TObject *Sender);
        void __fastcall ZoomComboBoxKeyPress(TObject *Sender, char &Key);
        void __fastcall NormZoomButtonClick(TObject *Sender);
        void __fastcall ZoomInButtonClick(TObject *Sender);
        void __fastcall ZoomOutButtonClick(TObject *Sender);
        void __fastcall ResizeImageButtonClick(TObject *Sender);
        void __fastcall ProgressTimerTimer(TObject *Sender);
        void __fastcall SaveButtonClick(TObject *Sender);
        void __fastcall MainStatusBarDrawPanel(TStatusBar *StatusBar,
          TStatusPanel *Panel, const TRect &Rect);
        void __fastcall MainStatusBarClick(TObject *Sender);
        void __fastcall AbstractGeneratorButtonClick(TObject *Sender);
        void __fastcall NewButtonClick(TObject *Sender);
        void __fastcall GaussBlurSpeedButtonClick(TObject *Sender);
        void __fastcall GaussGeneratorSpeedButtonClick(TObject *Sender);
        void __fastcall TriangleGeneratorSpeedButtonClick(TObject *Sender);
        void __fastcall TriangBlurSpeedButtonClick(TObject *Sender);
        void __fastcall MainScrollBoxMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall MainScrollBoxMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall MainScrollBoxMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall SharpenGeneratorSpeedButtonClick(TObject *Sender);
        void __fastcall SharpenSpeedButtonClick(TObject *Sender);
        void __fastcall FunctionSpeedButtonClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall EdgeGeneratorSpeedButtonClick(TObject *Sender);
        void __fastcall FindEdgesSpeedButtonClick(TObject *Sender);
        void __fastcall ColorDepthSpeedButtonClick(TObject *Sender);
        void __fastcall AboutSpeedButtonClick(TObject *Sender);
        void __fastcall FlipRotateSpeedButtonClick(TObject *Sender);
        void __fastcall FFTSpeedButtonClick(TObject *Sender);
        void __fastcall RevFFTSpeedButtonClick(TObject *Sender);
        void __fastcall FFTGaussSpeedButtonClick(TObject *Sender);
        void __fastcall CurvesSpeedButtonClick(TObject *Sender);
        void __fastcall AutoLevelsButtonClick(TObject *Sender);
        void __fastcall UserFilterSpeedButtonClick(TObject *Sender);
private:	// User declarations
        void __fastcall ResizeTerminateEvent(TObject *Sender);
        TBitmapProcesorThread *resizerThread;
        bool MouseDown;
        TPoint MouseDownCoords;
        TWindowState lastWindowState;
        TRect lastBoundsRect;
public:		// User declarations
        __fastcall TLisoszopMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TLisoszopMainForm *LisoszopMainForm;
//---------------------------------------------------------------------------
#endif
