//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OpenRawUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TOpenRawForm *OpenRawForm;
//---------------------------------------------------------------------------
__fastcall TOpenRawForm::TOpenRawForm(TComponent* Owner)
        : TForm(Owner)
{
	TranslateForm(this);
}
//---------------------------------------------------------------------------

void __fastcall TOpenRawForm::CancelSpeedButtonClick(TObject *Sender)
{
  delete RawStream;
  RawStream=NULL;
  ModalResult=mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::OpenSpeedButtonClick(TObject *Sender)
{
  ReloadImage();
  delete RawStream;
  RawStream=NULL;
  ModalResult=mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::FormShow(TObject *Sender)
{
  RawStream=new TFileStream(RawFileName,fmOpenRead|fmShareDenyNone);
  OpenModeRadioGroupClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::ReloadImage()
{
  //Deklarujemy zmienne i czytamy te potrzebne w kadym trybie
  TPixelFormat bpp;//pf1bit, pf4bit, pf8bit, pf15bit, pf16bit, pf24bit, pf32bit
  int bmWidth=WidthSpinEdit->Value;
  uint StartSkip=SkipStartSpinEdit->Value;//StrToIntDef(SkipStartComboBox->Text, 0);
  uint PalMul=1;
  uint bytesPerPix=1;
  int MaxLines=StrToIntDef(MaxLinesComboBox->Text, -1);
  TLoadDirection Direction;
  if (DirectionRadioGroup->ItemIndex==0)
      Direction=ldTopToBottom;
    else
      Direction=ldBottomToTop;
  if (bmWidth<1) return;
  //Czytamy zmienne zalene od trybu i wczytujemy RAWa
  uint OpenMode=OpenModeRadioGroup->ItemIndex;
  switch (OpenMode)
    {
    case 0:
        PalMul=PalMulSpinEdit->Value;
        switch (BPPRadioGroup->ItemIndex)
          {
          case 0:bpp=pf1bit;break;
          case 1:bpp=pf4bit;break;
          default:
          case 2:bpp=pf8bit;break;
          case 3:bpp=pf15bit;break;
          case 4:bpp=pf16bit;break;
          case 5:bpp=pf24bit;break;
          case 6:bpp=pf32bit;break;
          }
        LoadRaw(RawStream,WorkImage->Picture->Bitmap,StartSkip,bmWidth,MaxLines,bpp,Direction,PalMul,PalFileEdit->Text);
        break;
    case 1:
        bpp=pf24bit;
        bytesPerPix=BytesPerPixEdit->Value;
        LoadMultibyteRaw(RawStream,WorkImage->Picture->Bitmap,StartSkip,bmWidth,MaxLines,bytesPerPix,Direction);
        break;
    }
  WorkImage->Invalidate();
  WorkImage->Repaint();
}

//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::LoadRaw(TStream *FileStream,Graphics::TBitmap *Bitmap,uint StartSkip,uint bmWidth,int MaxLines,TPixelFormat bpp,TLoadDirection Direction,float PalMul,const String &PalFile)
{
  Extended rawDataSize=Extended(RawStream->Size)-StartSkip;
  if (rawDataSize<0.9)
  {
    StartSkip=max(RawStream->Size-1,0);
    rawDataSize=1.0;
  }
  FileStream->Seek(StartSkip,soFromBeginning);
  //Liczymy parametry
  uint fileLineLength;
  int bmHeight;
  switch (bpp)
    {
    case pf1bit:bmHeight=Ceil(rawDataSize*8/bmWidth);fileLineLength=bmWidth/8;break;
    case pf4bit:bmHeight=Ceil(rawDataSize*2/bmWidth);fileLineLength=bmWidth/2;break;
    default:
    case pf8bit:bmHeight=Ceil(rawDataSize/bmWidth);fileLineLength=bmWidth;break;
    case pf15bit:bmHeight=Ceil(rawDataSize*15/(32.0*bmWidth));fileLineLength=bmWidth*2;break;
    case pf16bit:bmHeight=Ceil(rawDataSize/(2.0*bmWidth));fileLineLength=bmWidth*2;break;
    case pf24bit:bmHeight=Ceil(rawDataSize/(3.0*bmWidth));fileLineLength=bmWidth*3;break;
    case pf32bit:bmHeight=Ceil(rawDataSize/(4.0*bmWidth));fileLineLength=bmWidth*4;break;
    }
  if ((MaxLines>0)&&(bmHeight>MaxLines)) bmHeight=MaxLines;
  if (bmWidth<1) bmWidth=1;
  if (bmHeight<1) bmHeight=1;
  //Przygotowujemy map
  Bitmap->FreeImage();
  Bitmap->Width=bmWidth;
  Bitmap->Height=bmHeight;
  Bitmap->PixelFormat=bpp;
    {
    bool UseDefaultPalette=false;
    if ((PalFile.Length()<1) || (!FileExists(PalFile)))
      {
      UseDefaultPalette=true;
      }
     else
      __try
        {
        TFileStream *PalStream=new TFileStream(PalFile,fmOpenRead|fmShareDenyNone);
        MakeFromStreamBitmapPalette(Bitmap,PalMul,PalStream);
        delete PalStream;
        }
      __except (EXCEPTION_EXECUTE_HANDLER)
        {
        UseDefaultPalette=true;
        }
    if (UseDefaultPalette) MakeMonochromeBitmapPalette(Bitmap,PalMul);
    }
  //I do niej zapisujemy
  switch (Direction)
    {
    case ldTopToBottom:
      {
      for (int hNum=0;hNum<bmHeight;hNum++)
        {
        FileStream->Read(Bitmap->ScanLine[hNum], fileLineLength);
        }
      };break;
    case ldBottomToTop:
      {
      for (int hNum=bmHeight-1;hNum>=0;hNum--)
        {
        FileStream->Read(Bitmap->ScanLine[hNum], fileLineLength);
        }
      };break;
    }


}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::LoadMultibyteRaw(TStream *FileStream,Graphics::TBitmap *Bitmap,uint StartSkip,uint bmWidth,int MaxLines,uint bytespp,TLoadDirection Direction)
{
  FileStream->Seek(StartSkip,soFromBeginning);
  Extended rawDataSize=Extended(RawStream->Size)-StartSkip;
  if (rawDataSize<=StartSkip) return;
  //Liczymy parametry
  uint fileLineLength;
  int bmHeight;
  bmHeight=Ceil(rawDataSize/bytespp/bmWidth);
  fileLineLength=bmWidth*bytespp;
  if ((MaxLines>0)&&(MaxLines<bmHeight)) bmHeight=MaxLines;
  //Przygotowujemy map
  Bitmap->FreeImage();
  Bitmap->Width=bmWidth;
  Bitmap->Height=bmHeight;
  Bitmap->PixelFormat=pf24bit;
  //MakeMonochromeBitmapPalette(Bitmap,PalMul);
  char *readBuf=new char[fileLineLength+1];
  //I do niej zapisujemy
  switch (Direction)
    {
    case ldTopToBottom:
      {
      for (uint hNum=0;hNum<(uint)bmHeight;hNum++)
        {
        FileStream->Read(readBuf, fileLineLength);
        char *bmpLine=(char *)Bitmap->ScanLine[hNum];
        if (bytespp>2)
          {
          for (uint vNum=0;vNum<bmWidth;vNum++)
            {
            int valG=0;
            int valB=0;
            int valR=0;
            uint bytesPerGB=bytespp/3;
            uint bytesPerR=bytespp-bytesPerGB;
            uint vnumBytesPP=vNum*bytespp;
            for (uint vByte=0;vByte<bytesPerGB;vByte++)
              {
              valG+=readBuf[vnumBytesPP+vByte];
              valB+=readBuf[vnumBytesPP+bytesPerGB+vByte];
              }
            vnumBytesPP+=2*bytesPerGB;
            for (uint vByte=0;vByte<bytesPerR;vByte++)
              {
              valR+=readBuf[vnumBytesPP+vByte];
              }
            bmpLine[3*vNum]=valG/bytesPerGB;
            bmpLine[3*vNum+1]=valB/bytesPerGB;
            bmpLine[3*vNum+2]=valR/bytesPerR;
            }
          }
         else //if (bytespp>2)
          {
          for (uint vNum=0;vNum<bmWidth;vNum++)
            {
            int valRGB=0;
            uint bytesPerRGB=bytespp;
            uint vnumBytesPP=vNum*bytespp;
            for (uint vByte=0;vByte<bytesPerRGB;vByte++)
              {
              valRGB+=readBuf[vnumBytesPP+vByte];
              }
            bmpLine[3*vNum]=valRGB/bytesPerRGB;
            bmpLine[3*vNum+1]=valRGB/bytesPerRGB;
            bmpLine[3*vNum+2]=valRGB/bytesPerRGB;
            }
          }
        }
      };break;
    case ldBottomToTop:
      {
      for (int hNum=bmHeight-1;hNum>=0;hNum--)
        {
        FileStream->Read(readBuf, fileLineLength);
        char *bmpLine=(char *)Bitmap->ScanLine[hNum];
        if (bytespp>2)
          {
          for (uint vNum=0;vNum<bmWidth;vNum++)
            {
            int valG=0;
            int valB=0;
            int valR=0;
            uint bytesPerGB=bytespp/3;
            uint bytesPerR=bytespp-bytesPerGB;
            uint vnumBytesPP=vNum*bytespp;
            for (uint vByte=0;vByte<bytesPerGB;vByte++)
              {
              valG+=readBuf[vnumBytesPP+vByte];
              valB+=readBuf[vnumBytesPP+bytesPerGB+vByte];
              }
            vnumBytesPP+=2*bytesPerGB;
            for (uint vByte=0;vByte<bytesPerR;vByte++)
              {
              valR+=readBuf[vnumBytesPP+vByte];
              }
            bmpLine[3*vNum]=valG/bytesPerGB;
            bmpLine[3*vNum+1]=valB/bytesPerGB;
            bmpLine[3*vNum+2]=valR/bytesPerR;
            }
          }
         else //if (bytespp>2)
          {
          for (uint vNum=0;vNum<bmWidth;vNum++)
            {
            int valRGB=0;
            uint bytesPerRGB=bytespp;
            uint vnumBytesPP=vNum*bytespp;
            for (uint vByte=0;vByte<bytesPerRGB;vByte++)
              {
              valRGB+=readBuf[vnumBytesPP+vByte];
              }
            bmpLine[3*vNum]=valRGB/bytesPerRGB;
            bmpLine[3*vNum+1]=valRGB/bytesPerRGB;
            bmpLine[3*vNum+2]=valRGB/bytesPerRGB;
            }
          }
        }
      };break;
    }
  delete readBuf;
}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::WidthSpinEditChange(TObject *Sender)
{
  ReloadImage();
}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::MaxLinesComboBoxChange(TObject *Sender)
{
  ReloadImage();
}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::BPPRadioGroupClick(TObject *Sender)
{
  ReloadImage();
}
//---------------------------------------------------------------------------
void TOpenRawForm::MakeMonochromeBitmapPalette(Graphics::TBitmap *dest,float PalMul)
{
  uint PalSize;
  uint PalMultip;
  TPixelFormat Format=dest->PixelFormat;
  switch (Format)
    {
    case pf1bit:PalSize=  2; PalMultip=255; break;
    case pf4bit:PalSize= 16; PalMultip= 16; break;
    case pf8bit:PalSize=256; PalMultip=  1; break;
    default:
    case pf15bit:
    case pf16bit:
    case pf24bit:
    case pf32bit:PalSize=  0; PalMultip=  1; break;
    }
//  dest->PixelFormat=Format;
  if (PalSize<1) return;
//  dest->Monochrome=true;
  TLogPalEx lPalEx;
  lPalEx.lPal.palVersion = 0x300;
  lPalEx.lPal.palNumEntries = PalSize;
  for (uint i=0;i<PalSize;i++)
    {
    lPalEx.lPal.palPalEntry[i].peRed=(char)(PalMul*i*PalMultip);
    lPalEx.lPal.palPalEntry[i].peGreen=(char)(PalMul*i*PalMultip);
    lPalEx.lPal.palPalEntry[i].peBlue=(char)(PalMul*i*PalMultip);
    lPalEx.lPal.palPalEntry[i].peFlags=0;
    }
  dest->Palette = CreatePalette(&lPalEx.lPal);
}
//---------------------------------------------------------------------------
void TOpenRawForm::MakeFromStreamBitmapPalette(Graphics::TBitmap *dest,float palMul,TStream *palStream)
{
  uint PalSize;
  TPixelFormat Format=dest->PixelFormat;
  switch (Format)
    {
    case pf1bit:PalSize=  2; break;
    case pf4bit:PalSize= 16; break;
    case pf8bit:PalSize=256; break;
    default:
    case pf15bit:
    case pf16bit:
    case pf24bit:
    case pf32bit:PalSize=  0; break;
    }
  dest->PixelFormat=Format;
  if (PalSize<1) return;
  TLogPalEx lPalEx;
  lPalEx.lPal.palVersion = 0x300;
  lPalEx.lPal.palNumEntries = PalSize;
  char palItem;
  for (uint i=0;i<PalSize;i++)
    {
    palStream->Read(&palItem,1);
    lPalEx.lPal.palPalEntry[i].peRed=(char)(palMul*palItem);
    palStream->Read(&palItem,1);
    lPalEx.lPal.palPalEntry[i].peGreen=(char)(palMul*palItem);
    palStream->Read(&palItem,1);
    lPalEx.lPal.palPalEntry[i].peBlue=(char)(palMul*palItem);
    lPalEx.lPal.palPalEntry[i].peFlags=0;
    }
  dest->Palette = CreatePalette(&lPalEx.lPal);
}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::DirectionRadioGroupClick(TObject *Sender)
{
  ReloadImage();
}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::SkipStartSpinEditChange(TObject *Sender)
{
  ReloadImage();
}
//---------------------------------------------------------------------------

void __fastcall TOpenRawForm::PalBrowseSpeedButtonClick(TObject *Sender)
{
  if (PalFileEdit->Text.Length()>0)
      PalOpenDialog->FileName=PalFileEdit->Text;
  if (PalOpenDialog->Execute())
      {
      PalFileEdit->Text=PalOpenDialog->FileName;
      }
}
//---------------------------------------------------------------------------

void __fastcall TOpenRawForm::PalFileEditChange(TObject *Sender)
{
  ReloadImage();
}
//---------------------------------------------------------------------------
void __fastcall TOpenRawForm::OpenModeRadioGroupClick(TObject *Sender)
{
  switch (OpenModeRadioGroup->ItemIndex)
    {
    case 0:
        PalMulLabel->Show();
        PalMulSpinEdit->Show();
        PalFileEdit->Show();
        PalFileLabel->Show();
        PalBrowseSpeedButton->Show();
        BPPRadioGroup->Show();
        BytesPerPixLabel->Hide();
        BytesPerPixEdit->Hide();
        break;
    case 1:
        PalMulLabel->Hide();
        PalMulSpinEdit->Hide();
        PalFileEdit->Hide();
        PalFileLabel->Hide();
        PalBrowseSpeedButton->Hide();
        BPPRadioGroup->Hide();
        BytesPerPixLabel->Show();
        BytesPerPixEdit->Show();
        break;
    }
  ReloadImage();
}
//---------------------------------------------------------------------------



