//---------------------------------------------------------------------------

#ifndef OpenRawUnitH
#define OpenRawUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "CSPIN.h"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <jpeg.hpp>
#include "FXProcs.h"
#include <Math.hpp>
#include "BitmapProcesorUnit.h"
#include <Dialogs.hpp>
#include <ActnList.hpp>
//---------------------------------------------------------------------------
enum TLoadDirection {ldTopToBottom, ldBottomToTop};
//---------------------------------------------------------------------------
class TOpenRawForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TLabel *Label1;
        TLabel *Label2;
        TComboBox *MaxLinesComboBox;
        TLabel *Label3;
        TCSpinEdit *WidthSpinEdit;
        TRadioGroup *BPPRadioGroup;
        TLabel *PalFileLabel;
        TEdit *PalFileEdit;
        TScrollBox *MainScrollBox;
        TImage *WorkImage;
        TSpeedButton *OpenSpeedButton;
        TSpeedButton *CancelSpeedButton;
        TSpeedButton *PalBrowseSpeedButton;
        TRadioGroup *DirectionRadioGroup;
        TCSpinEdit *SkipStartSpinEdit;
        TOpenDialog *PalOpenDialog;
        TLabel *PalMulLabel;
        TCSpinEdit *PalMulSpinEdit;
        TRadioGroup *OpenModeRadioGroup;
        TLabel *BytesPerPixLabel;
        TCSpinEdit *BytesPerPixEdit;
        TActionList *ActionList1;
        TAction *OpenAction;
        void __fastcall CancelSpeedButtonClick(TObject *Sender);
        void __fastcall OpenSpeedButtonClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall WidthSpinEditChange(TObject *Sender);
        void __fastcall MaxLinesComboBoxChange(TObject *Sender);
        void __fastcall BPPRadioGroupClick(TObject *Sender);
        void __fastcall DirectionRadioGroupClick(TObject *Sender);
        void __fastcall SkipStartSpinEditChange(TObject *Sender);
        void __fastcall PalBrowseSpeedButtonClick(TObject *Sender);
        void __fastcall PalFileEditChange(TObject *Sender);
        void __fastcall OpenModeRadioGroupClick(TObject *Sender);
private:	// User declarations
        void MakeMonochromeBitmapPalette(Graphics::TBitmap *dest,float PalMul);
        void MakeFromStreamBitmapPalette(Graphics::TBitmap *dest,float PalMul,TStream *palStream);
public:		// User declarations
        __fastcall TOpenRawForm(TComponent* Owner);
        String RawFileName;
        TStream *RawStream;
        void __fastcall ReloadImage();
        void __fastcall LoadRaw(TStream *FileStream,Graphics::TBitmap *Bitmap,uint StartSkip,uint bmWidth,int MaxLines,TPixelFormat bpp,TLoadDirection Direction,float PalMul,const String &PalFile);
        void __fastcall LoadMultibyteRaw(TStream *FileStream,Graphics::TBitmap *Bitmap,uint StartSkip,uint bmWidth,int MaxLines,uint bpp,TLoadDirection Direction);
};
//---------------------------------------------------------------------------
extern PACKAGE TOpenRawForm *OpenRawForm;
//---------------------------------------------------------------------------
#endif
